/*
 * File: BootROM - bios.h
 *
 * Contains:
 *
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 *
 *  Copyright:	 1989-2012 by Guy McIlroy
 *  All rights reserved.
 *
 *  This module contains confidential, unpublished, proprietary source code.
 *  The copyright notice above does not evidence any actual or intended
 *  publication of such source code.
 *
 *  This code may only be used under licence from Koliada, LLC - www.koliada.com
 *
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 *
 */
#ifndef __BIOS_H
#define __BIOS_H

// stdio indexes
#define _STDIN		0
#define _STDOUT	1
#define _STDERR	2
#define _STDDBG	3
#define _STDPRN	4
#define _STDLOG	5
#define _STDKEY	6

int stdio(word index, int c);	// call the indexed stdio function

// these may be overloaded by the target config
int sysGetch();			// stdin
int sysPutchOut(int c);	// stdout
int sysPutchErr(int c);	// stderr
int sysPutchDbg(int c);	// stddbg
int sysPutchPrn(int c);	// stdprn
int sysPutchLog(int c);	// stdlog
int sysGetchWait(word ms);// stdget

#define sysPutch sysPutchOut
#define getkey sysGetchWait

// some basic formated output primitives
int print(const char *, ...);
int error(const char *, ...);
int debug(const char *, ...);
int trace(const char *, ...);			// outputs to prn & log

#endif //__BIOS_H
