/*
 * File:
 *
 * Contains:
 *
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 *
 *  Copyright:	 1989-2014 by Guy McIlroy
 *  All rights reserved.
 *
 *  This module contains confidential, unpublished, proprietary source code.
 *  The copyright notice above does not evidence any actual or intended
 *  publication of such source code.
 *
 *  This code may only be used under licence from Koliada, LLC - www.koliada.com
 *
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 *
 */
#ifndef SEQCOUNT_H
#define SEQCOUNT_H

typedef unsigned char seqBool;
typedef unsigned char seqType;
#define sizeofSeq 1

// we don't use a priority value in this implementation

seqType seqClock(seqType seq);						// clock a sequence number
seqType seqDelta(seqType s1, seqType s2);			// calculates the delta of s2 in advance of s1
seqBool seqNewer(seqType seq1, seqType seq2);	// returns (s1 'newer than' s2)
seqBool seqError(seqType seq);						// check to see if seq is in 'error'

#endif//SEQCOUNT_H
