/*
 *	File:
 *
 *	Contains: IAR compiler pecadillos
 *
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 *
 *  Copyright  1989-2012 by Guy McIlroy
 *  All rights reserved.
 *
 *  This module contains confidential, unpublished, proprietary source code.
 *  The copyright notice above does not evidence any actual or intended
 *  publication of such source code.
 *
 *  This code may only be used under licence from Koliada, LLC - www.koliada.com
 *
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 *
 */
#ifndef __COMPILER_H
#define __COMPILER_H
#ifndef __IAR_H
#define __IAR_H

#ifndef __CONST
	#define CONST const
	#define __CONST
#endif
#define PACKED

#define __NEAR_FUNC __near_func
#define NEAR_FUNC __near_func

#define COMMA_ELLIPSIS 1	// fn(args, ...)
#define USE_STRFMT_BIOS 1

#include <stdarg.h>

// ((word *)args)[i] for va_list

////////////////////////////////////////////////

#if __IAR_SYSTEMS_ICC__ >= 2

	#if defined(__ICC78K__) || defined(__ICCM32C__)
#error "va_word is undefined!!!!!!!!!!!!!!"
		#define va_arg(ap,mode) \
		  (sizeof(mode) < sizeof(int) ? (*(mode *)(*(int **)ap)++) : *(*(mode **) ap)++)
	#else
		#ifdef __VA_STACK_DECREASING__
			#if __VA_STACK_DECREASING__
			  #define va_word(ap, index) ((*(word **)ap)[index])
			#else
		#error "va_word is undefined!!!!!!!!!!!!!!"
				#define va_arg(ap,type) (*--(*(type **)ap))
			#endif
		#endif
	#endif

#else /* __IAR_SYSTEMS_ICC__ >= 2 */
	#if ((__TID__ >> 8) & 0x7f) == 4
#error "va_word is undefined!!!!!!!!!!!!!!"
		#define va_arg(ap,mode) *(mode *) _get_varg (ap, _argt$(mode), sizeof(mode))
	#endif

	#if ((__TID__ >> 8) & 0x7f) == 36
#error "va_word is undefined!!!!!!!!!!!!!!"
		#define va_arg(ap,mode) (*--(*(mode **)ap))
	#endif


	#if ((__TID__ >> 8) == 1 && (__TID__ & 15) == 0) || ((__TID__ >> 8) & 0x7f) == 19
#error "va_word is undefined!!!!!!!!!!!!!!"
		#define va_arg(ap,mode) (*--(*(mode **)ap))
	#endif

	#if ((__TID__ >> 8) & 0x7f) == 9  || /* IANB 97.06.26 */        \
		 ((__TID__ >> 8) & 0x7f) == 10 || /* IANB 97.06.26 */        \
		 ((__TID__ >> 8) & 0x7f) == 15 ||                            \
		 ((__TID__ >> 8) & 0x7f) == 16 ||                            \
		 ((__TID__ >> 8) & 0x7f) == 20 ||                            \
		 ((__TID__ >> 8) & 0x7f) == 21 || /* IERA 94.01.16 */        \
		 ((__TID__ >> 8) & 0x7f) == 23    /* IHAT 94.04.18 */
#error "va_word is undefined!!!!!!!!!!!!!!"
		#define va_arg(ap,mode) \
		  (sizeof(mode) == 1 ? (*(mode *)(*(int **)ap)++) : *(*(mode **) ap)++)

	#endif

	#if ((__TID__ >> 8) & 0x7f) == 29 ||                          \
		 ((__TID__ >> 8) & 0x7f) == 30 || /* IBEV 97.07.14 */      \
		 ((__TID__ >> 8) & 0x7f) == 41 || /* IASL 97.06.09 */      \
		 ((__TID__ >> 8) & 0x7f) == 42    /* IBEV 97.12.18 */
#error "va_word is undefined!!!!!!!!!!!!!!"
		#define va_arg(ap,mode) \
		  (sizeof(mode) < sizeof(int) ? (*(mode *)(*(int **)ap)++) : \
									  *(*(mode **) ap)++)

	#endif

	#if ((__TID__ >> 8) & 0x7f) == 6   /* ICLM 93.11.01 */
#error "va_word is undefined!!!!!!!!!!!!!!"
		#define va_arg(ap,mode) (*(*(mode **) ap)++)
	#endif

	// All ICC compilers except those listed above.
#error "va_word is undefined!!!!!!!!!!!!!!"
	#define va_arg(ap,mode) (*(*(mode **) ap)++)
#endif /* __IAR_SYSTEMS_ICC__ >= 2 */

#endif//__IAR_H
#endif//__COMPILER_H
