/*
 * File: Koliada - dataseg.h
 *
 * Contains: dataseg defines
 *
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 *
 *  Copyright  1989-2012 by Guy McIlroy
 *  All rights reserved.
 *
 *  This module contains confidential, unpublished, proprietary source code.
 *  The copyright notice above does not evidence any actual or intended
 *  publication of such source code.
 *
 *  This code may only be used under licence from Koliada, LLC - www.koliada.com
 *
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 *
 */
// map to the apporiate datasegment #defines
#ifndef __DATASEG_H
#define __DATASEG_H

// some cpus (eg MIPS) use dataseg relative addressing
// these macros allow jumping between datasegs

#define DATASEG		(0)
#define _pushDS()		-1
#define _popDS(ds)	-1
#define WAIT_DS		{
#define POST_DS		;}
#define __ds			0

// uncomment this if start.c should init the dataseg (i.e. system/app loader doesn't do it)
#define INIT_DATASEG 0

#endif//__DATASEG_H
