/*
 * File: usbLink.h
 *
 * Contains:
 *
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 *
 *  Copyright:	 1989-2012 by Guy McIlroy
 *  All rights reserved.
 *
 *  This module contains confidential, unpublished, proprietary source code.
 *  The copyright notice above does not evidence any actual or intended
 *  publication of such source code.
 *
 *  This code may only be used under licence from Koliada, LLC - www.koliada.com
 *
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 *
 */
#ifndef __USBLINK_H
#define __USBLINK_H

#define DEFAULT_BAUD ((UInt32)-1)	// uses default set in BoardConfig

// usbLink.c
void usbFlush();

int usbGetc(word port);								// obtain next byte, as an unsigned char converted to an int, from a usb port
int usbPutc(int c, word port);					// writes c (converted to an unsigned char) to usb port.
int usbPuts(char *s, word port);					// writes string *s, followed by a <newline>, to the usb port.
int usbGets(char *s, word len, word port);	// reads bytes from the standard input stream, stdin, into the array pointed to by s,
															// until a <newline> is read or an end-of-file condition is encountered.
															// Any <newline> is discarded and a null byte is placed immediately after the last byte read into the array.
int usbWrite(word port, byte *buf, word len);
int usbRead(word port, byte *buf, word len);

void usbInit(word port, UInt32 baud, EVENT rxReadyEvent);

#endif//__USBLINK_H
