#ifndef TCA6416A_H_
#define TCA6416A_H_

#include "ctypes.h"
#include "pindefs.h"
#include "hal_i2c.h"
/*
TCA6416A
- ADDRESS DEFINTIONS
- PIN DEFINITIONS
- FUNCTION DECLARATIONS

MeshCandy Badge
Board: TENA006
*/

#define TCA6416A_ADDR 0x20 // IO expander I2C address

#define PORT0_IN 0x00   // Port 0 Input register (read only)
#define PORT0_OUT 0x02  // Port 0 Output register (read/write)
#define PORT0_INV 0x04  // Port 0 Polarity inversion register (read/write)
#define PORT0_CFG 0x06  // Port 0 Configuration Register (read/write)
#define PORT1_IN 0x01   // Port 1 Input register (read only)
#define PORT1_OUT 0x03  // Port 1 Output register (read/write)
#define PORT1_INV 0x05  // Port 1 Polarity inversion register (read/write)
#define PORT1_CFG 0x07  // Port 1 Configuration Register (read/write)

#define LED_ON          0x01
#define SENSOR_ON       0x02
#define BUTTON_3        0x04
#define P03             0x08
#define P04             0x10
#define P05             0x20
#define P06             0x40
#define P07             0x80
#define P10             0x01
#define P11             0x02
#define P12             0x04
#define P13             0x08
#define GYRO_ON         0x30
#define GYRO_INT1       0x40
#define GYRO_INT2       0x80

void waitExpander();
void postExpander();

void initExpander(void);
void resetExpander(void);
byte readExpander(byte addr);
void writeExpander(byte addr, byte value, UInt8 nBytes);

#endif /* TCA6416A_H_ */
