#include <string.h>
#include "EtherDATA.h"
#include <stdio.h>
#include "Bridge.ddl.h"

// here we are looking at >remote< rssi data which is mapped to emNeighborTable

#define krssiSampleInterval 	TICKS(1000)
int output(const char *fmt, ...);
UInt16 address;
void rssiGetHandler(string remote);
string device_name;

typedef struct
	{
	word addr ;
	signed char rssi ;
	} NeighborTable;

NeighborTable table[8];

// define a accel sample timer
DefineTimer(rssiSampleTimer);
void rssiSampleTimerHandler(TIMER e, dbValue ref)
	{
	dbGet(emNeighborTable, &table);
	dbSetValue(NULL, rssiTable, &table);
	}

void initRSSI()
	{
	// set up and start the accelerometer sampling timer
	objectCreate(rssiSampleTimer, kIntervalTimer, krssiSampleInterval);// once per 5 second
	OnEvent(rssiSampleTimer, (HANDLER) rssiSampleTimerHandler);
	cmStartTimer(rssiSampleTimer);

	dbPublish(rssiTable);
	}