#include "EtherDATA.h"
#include "led.h"
#include "pCache.h"
#include "pindefs.h"
#include "sysgpio.h"
#include "string.h"
#include "kNode.ddl.h"

int printf(const char *, ...);
void initBattery();
void initButton();
void initAccel();
void termAccel();
void initUI();
void initRSSI();
void termRSSI();
void initLED();
void initHumi();
void termHumi();
void ledBlink(Pattern pattern);
void initPCACHE(void);
int delCompare(void *key, void *buf, SIZE_T size);
void init_dataLog(void);
int start_dataLog(UInt16 frequency);
void initTimers();
void MemledOn(word led, word delay);
void Sensor_Pwr(bool option);
ExternTimer(configDeviceLEDTimer);
void start_Humi();
void init_syncLost();
void initExpander(void);
void initBuzzer();
void init_recovery();

extern UInt16 sync_interval = 10000; //PREV 10000
extern UInt16 groupResetCounter;





// Jord's 




//#if 0


#define kConfigType       kFirstpCacheType + 3		// cached record type
#define ACCEL  0
#define HUMI   0
#define NEIGHBORTABLE   0

#define kConfigType       kFirstpCacheType + 3		// cached record type
#define ACCEL  0
#define HUMI   0
#define NEIGHBORTABLE   0





/****************************************************************************/
/*                      configValue DATA OBJECT                             */
/* Format:[4-bytes for new name][1 - byte for peripherals]                  */
/* Example: "Adam7"                                                         */
/*      Drivers: [0] - NeighborTable (initRssi)
                 [1] - Temp/Humi/Pressure Service (startHumi)
                 [2] - Accelerometer (initAccel)
*****************************************************************************/
void (*initValue[3])() = {initRSSI, start_Humi, initAccel};
void (*termValue[3])() = {termRSSI, termHumi, termAccel};
STATUS configRequest(OBJECT o) // called everytime configValue is written to
{
	dbValue configValue = (dbValue)o;
	string data;
        string newName;
        char newData[5];
        byte request = 0;


        memset(newData, 0, sizeof(newData));
        
	dbGet(configValue, &data);
        strnbuf(5, newData, 0, "%s", data);



        memcpy(&request, &newData[4], sizeof(request));
        memset(&newData[4], 0, 1);
        
        strcpy(data, newData);


        if(strcmp("0000", newData))
        {
        printf("my new name is: %s\n", data);
        dbRename(nodeAddr, data);
        }
        
        if (request >= '0')
        {
        request = request - '0';
        }
        
         if((locChunk(kConfigType, NULL, delCompare)) == NULL);
         else
         {
            for (int i = 0; i < 3; i ++)
            {
              termValue[i]();
            }
         }
        
        delChunk(kConfigType, NULL, delCompare);       // delete old threshold value from pCache
        newChunk(kConfigType, &request, 1);            // save new threshold value in pCache
        
        for (int i = 0; i < 3; i ++)
        {
          if (request % 2)
          {
          initValue[i]();
          }
          else
          {
          termValue[i]();
          }
          request = request / 2;
        }
        
        cmStartTimer(configDeviceLEDTimer);



    return 0;
}


// end of jord's 

//#endif



























void TopledOn(word delay);
int main(int argc, char **argv)
	{
	(void) argv;
	(void) argc;

	initExpander();
	initLED();
	initButton();

#if 0
	/* Define when BAT values are finalized. This is designed to prevent device from joining mesh if battery is low*/
	int value = adc(0x00 | 0x30 | 0x0f) >> 3; // VDD/3 ref
	if (value < 2150)
		while(1)
			{
			ledBlink(redFlashPattern);
			sysDelayMs(250);
			}
#endif

	setMeshPendCount(1);
	setMeshWindow(128);
	setMeshInterval(sync_interval);
	//printf("Mesh Interval is set at %d ms\n", sync_interval);

	// see if we've been given a name as part of the config
	dbInit(sysGetEnv("emNodeName"));

	emSetCntl(emMeshChannel, 15);

	//init_syncLost(); // define Sync Lost Callback
	emMeshStart();

	printf("Node %0x started as %s \"%s\"\n\n", nodeAddr, argv[0], nodeName);

	initPCACHE();
	void initConfig(); initConfig();

	initBattery(); // delay 30 ms before start timer

	cmDelayMs(500);
	initUI();

	initHumi();

	start_Humi();
	cmDelayMs(500);
	//initRSSI();

	initBuzzer();

	//initAccel();
	//init_dataLog();
	//start_dataLog(0);
	//cmDelayMs(500);
	//init_recovery();

	WaitEvent(0, 0);// never returns
	}
