#include "EtherDATA.h"
#include "sysGpio.h"
#include "led.h"
#include "buzzer.h"
#include "TCA6416A.h"
#define led_PWM 10

UInt8 count;
void playTune(Tune tune);
ExternTimer(lowBatLEDTimer);
UInt16 loop_counter = 0;
word topLed_state = 0;
int printf(const char *, ...);
extern SysPowerMode(*chainEventSleepNotice)(SysPowerMode);  // defined in TCA6416A.c


DefineTimer(pwmTimer);
void pwmTimerHandler(TIMER e, word led)
	{
	if (led == LED_BOTH)
		{
		GPIO.XOR(LED_GRN);
		GPIO.XOR(LED_RED);
		}
	else
		{
		GPIO.XOR(led);
		}
	}

DefineTimer(pwmTopTimer); // toggle TOP leds (controlled by IO_EXPANDER)
void pwmTopTimerHandler(TIMER e, word port)
	{
	selectI2C(TCA6416A_ADDR, i2cClock_267KHZ); // select IO expander as I2C slave
	//byte Port0 = readExpander(PORT0_IN); // read Input Port 0 register
	topLed_state ^= LED_ON;
	i2cTx(PORT0_OUT, (topLed_state));
	}

DefineTimer(ledDelayTimer); //the duration of 'blink' (called once blinking should stop)
void ledDelayTimerHandler(TIMER e, word led)
	{
	cmStopTimer(pwmTopTimer);
	cmStopTimer(pwmTimer);
	cmDelayMs(20);
	if (led == LED_BOTH)
		{
		GPIO.SET(LED_GRN, 0);
		GPIO.SET(LED_RED, 0);
		}
	else if (led == 4)
		{
		selectI2C(TCA6416A_ADDR, i2cClock_267KHZ); // select IO expander as I2C slave
		topLed_state &= ~(LED_ON);
		i2cTx(PORT0_OUT, (topLed_state));
		cmStopTimer(pwmTopTimer);
		//printf("TOP LED OFF \n"); //debug statement
		}
	else
		{
		cmStopTimer(pwmTimer);
		GPIO.SET(led, 0);
		}
	}

void MemledOn(word led, word delay) //Red or Green LEDs
	{
	cmStartTimer(pwmTimer, led);
	cmSetTimer(ledDelayTimer, TICKS(delay));
	cmStartTimer(ledDelayTimer, led);
	}

void TopledOn(word delay) //bright TOP LEDs
	{
	topLed_state = readExpander(PORT0_IN); // read Input Port 0 register
	cmStartTimer(pwmTopTimer, 0);
	cmSetTimer(ledDelayTimer, TICKS(delay));
	cmStartTimer(ledDelayTimer, 4);
	}

DefineTimer(configDeviceLEDTimer);// Config LED pattern timer
void configDeviceLED(TIMER t)
	{
	MemledOn(LED_BOTH, 100);
	}

DefineTimer(findTagLEDTimer);// find Tag LED timer
void findTagLED(TIMER t, UInt16 timer)
	{
	if (loop_counter >= timer)
		{
		loop_counter = 0;
		cmStopTimer(findTagLEDTimer);
		stopBuzzer();
		}
	else
		{
		loop_counter ++;
		MemledOn(LED_GRN, 100);
		playTune(msgTune);
		}
	}

#if 0
STATUS ledRequest(OBJECT o, bool isArray, byte index) // called whenever device's led dataobject is written to
	{
	dbValue led = (dbValue)o;
	byte request;

	dbGet(led, &request);
	if (request >= '0') // if  request is an ASCII equivalent
		{
		request = request - '0';
		}
	//debug(">>%s - request %u\n", __func__, request);
	switch (request)
		{
		case 0:
				{
				cmStopTimer(configDeviceLEDTimer);
				cmStopTimer(findTagLEDTimer);
				break;
				}
		case 1:
				{
				cmStopTimer(configDeviceLEDTimer);
				cmStartTimer(findTagLEDTimer, 30); // start findTagLEDTimer (interval timer for 30 seconds)
				break;
				}

		case 2: // find tag
				{
				break;
				//cmStartTimer(findTagLEDTimer, led);
				}
		}
	/*if (request < sizeofLedList)
		ledBlink(ledList[request]);*/

	return 0;
	}
#else
#warning ledRequest not currently supported!
STATUS ledRequest(OBJECT o, bool isArray, byte index)
	{
	debug("%s\n", __FUNC__);
	return 0;
	}
#endif

void initLED()
	{
	// set up and start the led delay timer
	objectCreate(ledDelayTimer, kSingleShotTimer, TICKS(200));// once per second
	OnEvent(ledDelayTimer, (HANDLER) ledDelayTimerHandler);

	objectCreate(configDeviceLEDTimer, kIntervalTimer, TICKS(1250));
	OnEvent(configDeviceLEDTimer, (HANDLER) configDeviceLED);

	objectCreate(findTagLEDTimer, kIntervalTimer, TICKS(2000));
	OnEvent(findTagLEDTimer, (HANDLER) findTagLED);

	objectCreate(pwmTimer, kIntervalTimer, TICKS(10));
	OnEvent(pwmTimer, (HANDLER) pwmTimerHandler);

	objectCreate(pwmTopTimer, kIntervalTimer, TICKS(5));
	OnEvent(pwmTopTimer, (HANDLER) pwmTopTimerHandler);
	}
