/*
 * lis2dh.c
 *
 *  Created on: Jan 24, 2015
 *      Author: shaun.astar@gmail.com
 */


#include "lis2dh.h"
#include "hal_i2c.h"
#include "TCA6416A.h"

#define DATA_RATE		3			// ODR 2=10Hz, 3=25Hz, 4=50Hz See Table 28
int printf(const char *, ...);

void configDrop()
	{
	HalI2CDisable();
	//selectI2C(LIS2DH_I_AM_MASK, i2cClock_267KHZ);
	selectI2C(0x30, i2cClock_267KHZ);
	//sysDelayMs(5);

	// set up accel
	i2cTx(LIS2DH_CTRL_REG1, (DATA_RATE << 4) + 0x0F);	// normal mode all-axis enabled
	i2cTx(LIS2DH_CTRL_REG2, 0x00);
	i2cTx(LIS2DH_CTRL_REG3, 0x80); //click enabled on int1
	i2cTx(LIS2DH_CTRL_REG4, 0x20); // 4G -0x20
	i2cTx(LIS2DH_CTRL_REG5, 0x00);
	//i2cTx(LIS2DH_CTRL_REG6, 0x00); //interrupt active high
	i2cTx(LIS2DH_CTRL_REG6, 0x02); //interrupt active low


	i2cTx(LIS2DH_TIME_LIMIT, 0x08);//1
	i2cTx(LIS2DH_TIME_WINDOW, 0x0a);
	i2cTx(LIS2DH_CLICK_THS, 0x7f);//7
	i2cTx(LIS2DH_CLICK_CFG, 0x15);		// x & y & z axis single click

	//selectI2C(TCA6416A_ADDR, i2cClock_267KHZ); // select IO expander as I2C slave
	}


void configDoor()
	{
	HalI2CDisable();
	//selectI2C(LIS2DH_I_AM_MASK, i2cClock_267KHZ);
	selectI2C(0x30, i2cClock_267KHZ);
	//sysDelayMs(5);

	// set up accel
	i2cTx(LIS2DH_CTRL_REG1, (DATA_RATE << 4) + 0x0F);	 // normal mode all-axis enabled
	i2cTx(LIS2DH_CTRL_REG2, 0x00);
	i2cTx(LIS2DH_CTRL_REG3, 0x40);
	i2cTx(LIS2DH_CTRL_REG4, 0x00);                     // 2G
	i2cTx(LIS2DH_CTRL_REG5, 0x00);
	//i2cTx(LIS2DH_CTRL_REG6, 0x00);                   // interrupt active high
	i2cTx(LIS2DH_CTRL_REG6, 0x02);                     //interrupt active low

	i2cTx(LIS2DH_INT1_THS, 0x0F);		// 32LSB*15.625mg/LSB=0.5g
	i2cTx(LIS2DH_INT1_DURATION, 0x00);	// Duration= 10LSB*(1/10Hz) = 1sec
	//spiTx(LIS2DH_INT1_CFG, 0xCC);		// Direction detection on y-axis
	//spiTx(LIS2DH_INT1_CFG, 0xC3);		// Direction detection on x-axis
	i2cTx(LIS2DH_INT1_CFG, 0xCF);		// Direction detection on z-axis

	//selectI2C(TCA6416A_ADDR, i2cClock_267KHZ); // select IO expander as I2C slave
	}

STATUS accConfigChanged(OBJECT o)
	{
	byte request;
	dbValue accelConfig = (dbValue)o;

	dbGet(accelConfig, &request);
	if (request >= '0')
		{
		request = request - '0';
		}
	debug("accel Config: %d\n", request);

	//delChunk(kAccelType, NULL, delCompare);                         // delete old threshold value from pCache
	//newChunk(kAccelType, &request, sizeof(request));            // save new threshold value in pCache
	//memcpy(&accel_mode, &request, sizeof(request));
	switch (request)
		{
		case DROP:
				{
				configDrop();
				break;
				}
		case DOOR:
				{
				configDoor();
				break;
				}
		default:
				{
				configDoor();
				break;
				}
		}
	request += 2;

	//dbSet(accelValue, request);
	return 0;
	}



unsigned char lis2dh_getId(void)
	{
	volatile unsigned char id;
	id = i2cRx(LIS2DH_WHO_AM_I);
	return id;
	}

void lis2dh_init(void)
	{
	volatile unsigned char data;
	//configDrop();
	configDoor();
	data = lis2dh_getId();
	printf("WHO AM I : %s \n", data);
	/*
	        selectI2C(LIS2DH_I_AM_MASK, i2cClock_267KHZ);

		// set up accel
	        i2cTx(LIS2DH_CTRL_REG1, (DATA_RATE<<4)+0x0F);	// normal mode all-axis enabled
		///spiTx(LIS2DH_CTRL_REG2, 0x00);
	        i2cTx(LIS2DH_CTRL_REG2, 0x04);
		i2cTx(LIS2DH_CTRL_REG3, 0x40);
		i2cTx(LIS2DH_CTRL_REG4, 0x00);
		//spiTx(LIS2DH_CTRL_REG5, 0x05);
	        i2cTx(LIS2DH_CTRL_REG5, 0x04);
		//spiTx(LIS2DH_CTRL_REG6, 0xa0);
	        i2cTx(LIS2DH_CTRL_REG6, 0x80);

		//spiTx(LIS2DH_INT1_THS, 0x1f);		// 32LSB*15.625mg/LSB=0.5g
	        i2cTx(LIS2DH_INT1_THS, 0x2f);		// 32LSB*15.625mg/LSB=0.5g
		i2cTx(LIS2DH_INT1_DURATION, 0x0a);	// Duration= 10LSB*(1/10Hz) = 1sec
		i2cTx(LIS2DH_INT1_CFG, 0xf0);		// Direction detection on Z-axis
	        //spiTx(LIS2DH_INT1_CFG, 0x70);		// Direction detection on Z-axis

		//spiTx(LIS2DH_INT2_THS, 0x4f);		// 64*15.625mg/LSB=1g shock
		//spiTx(LIS2DH_INT2_DURATION, 0x3f);	// Duration= 0LSB*(1/10Hz) = 0 sec
		//spiTx(LIS2DH_INT2_CFG, 0xcf);
	        //spiTx(LIS2DH_INT2_CFG, 0xE2);

		i2cTx(LIS2DH_TIME_LIMIT, 0x08);//1
		i2cTx(LIS2DH_TIME_LATENCY, 0x10);//2
		//spiTx(LIS2DH_TIME_WINDOW, 0x0a);
	        i2cTx(LIS2DH_TIME_WINDOW, 0x80);
		i2cTx(LIS2DH_CLICK_THS, 0x4f);//7
		i2cTx(LIS2DH_CLICK_CFG, 0x0a);		// x & y axis double click

	        selectI2C(TCA6416A_ADDR, i2cClock_267KHZ); // select IO expander as I2C slave
	*/
	}

int lis2dh_getZ(void)
	{

	int data;

	data   = i2cRx(LIS2DH_OUT_Z_H);
	data <<= 8;
	data  += i2cRx(LIS2DH_OUT_Z_L);

	return data;

	}

int lis2dh_getClickSrc(void)
	{

	unsigned char data;

	data   = i2cRx(LIS2DH_CLICK_SRC);
	return data;

	}

int lis2dh_getInt2Src(void)
	{

	unsigned char data;

	data   = i2cRx(LIS2DH_INT2_SOURCE);
	return data;

	}

