#include <string.h>
#include "EtherDATA.h"
#include <stdio.h>
#include "kNode.ddl.h"

// here we are looking at >remote< rssi data which is mapped to emNeighborTable

#define krssiSampleInterval 	TICKS(30000)
int output(const char *fmt, ...);

UInt16 timer_counter = 0;

typedef struct // neighborTable structure
	{
	word addr ;
	signed char rssi ;
	} NeighborTable;

NeighborTable table[8];

// define a rssi sample timer
DefineTimer(rssiSampleTimer);
void rssiSampleTimerHandler(TIMER e, dbValue ref, UInt16 time)
	{
	timer_counter ++;
	if (timer_counter >= 6)
		{
		timer_counter = 0;
		dbGet(emNeighborTable, &table); // get neighbortable and store it in 'table'
		//dbSetValue(NULL, rssiTable, &table);
		dbSet(rssiTable, &table); // publish value
		printf("NT\n"); //debug statement
		}
	}

void initRSSI() // creates and starts neighborTable sample timer. Also sets rssiTable data object to Publish
	{
	// set up and start the accelerometer sampling timer
	objectCreate(rssiSampleTimer, kIntervalTimer, TICKS(krssiSampleInterval));// once per 30 second
	OnEvent(rssiSampleTimer, (HANDLER) rssiSampleTimerHandler);
	cmStartTimer(rssiSampleTimer, rssiTable, 2);

	dbPublish(rssiTable);
	}

void termRSSI()
	{
	dbWithdraw(rssiTable);
	cmStopTimer(rssiSampleTimer);
	}